/*----------------------------------------------------------------------
  Verifica se Numeros eh primo III
  ----------------------------------------------------------------------
  O Crivo de Eratstenes  um mtodo simples e prtico de se encontrar
  nmeros primos at um certo valor limite, criado por Eratstenes.

  Para exemplific-lo, vamos determinar a lista de nmeros entre 1 e 30.

    * Inicialmente, determina-se o maior nmero a ser checado. Ele 
      corresponde  raiz quadrada do valor limite, arredondado para 
      baixo. No caso, a raiz de 30, arredondada para baixo,  5.
    * Crie uma lista de todos os nmeros inteiros de 2 at o valor 
      limite:
          2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 
          21 22 23 24 25 26 27 28 29 30.
    * Encontre o primeiro nmero da lista. Ele  um nmero primo, 2.
    * Remova da lista todos os mltiplos do nmero primo encontrado. 
      No nosso exemplo, a lista fica: 
          2 3 5 7 9 11 13 15 17 19 21 23 25 27 29.
    * O prximo nmero da lista  primo. Repita o procedimento. No caso,
      o prximo nmero da lista  3. Removendo seus mltiplos, a lista 
      fica: 
          2 3 5 7 11 13 17 19 23 25 29. 
      O prximo nmero, 5, tambm  primo; a lista fica: 
          2 3 5 7 11 13 17 19 23 29. 
     5  o ltimo nmero a ser verificado, conforme determinado 
     inicialmente. Assim, a lista encontrada contm somente 
     nmeros primos.
 */

#include <stdio.h>

main()
{
  unsigned long n, j,
                iter_ext = 0,
                iter_int = 0;

  do { 
    printf("\nEntre com um numero inteiro positivo maior que 0: ");
  } while (scanf("%lu", &n) != 1);
  
  /* Se for indicado 1 ou 0, nao sao primos */
  if( n < 2)
    printf("\nO numero %5lu nao eh primo\n\n", n);
  else {
    /* verifica se eh primo usando o Crivo de Eratostenes */
    j = 0;
    /* se numero nao for par, aplica o crivo */
    if ( n != 2 &&  n % 2 )
      for (j = 3; (n % j != 0) && (j * j <= n); j += 2)
	iter_int++;
    
    /* se numero eh 2 ou passou pelo crivo */
    if ( n == 2 ||  j * j > n )
      printf("\nO numero %5lu eh primo\n", n);
    else
      printf("\nO numero %5lu nao eh primo\n", n);
    
    printf("\n\nNmero de iteraes: %5lu %5lu %5lu\n\n", iter_ext, iter_int, iter_ext + iter_int);
  }
}
